#define IMGFMT_YVYU 0x55595659

#define IMGFMT_YUY2 0x32595559

#define IMGFMT_UYVY 0x59565955

static void mirror(unsigned char* dst,unsigned char* src,int dststride,int srcstride,int w,int h,int bpp,unsigned int fmt){
    int y;
    for(y=0;y<h;y++){
        int x;
        switch(bpp){
        case 1:
            for(x=0;x<w;x++) dst[x]=src[w-x-1];
            break;
        case 2:
            switch(fmt){
            case IMGFMT_UYVY: {
                // packed YUV is tricky. U,V are 32bpp while Y is 16bpp:
                int w2=w>>1;
                for(x=0;x<w2;x++){
                    // TODO: optimize this...
                    dst[x*4+0]=src[0+(w2-x-1)*4];
                    dst[x*4+1]=src[3+(w2-x-1)*4];
                    dst[x*4+2]=src[2+(w2-x-1)*4];
                    dst[x*4+3]=src[1+(w2-x-1)*4];
                }
                break; }
            case IMGFMT_YUY2:
            case IMGFMT_YVYU: {
                // packed YUV is tricky. U,V are 32bpp while Y is 16bpp:
                int w2=w>>1;
                for(x=0;x<w2;x++){
                    // TODO: optimize this...
                    dst[x*4+0]=src[2+(w2-x-1)*4];
                    dst[x*4+1]=src[1+(w2-x-1)*4];
                    dst[x*4+2]=src[0+(w2-x-1)*4];
                    dst[x*4+3]=src[3+(w2-x-1)*4];
                }
                break; }
            default:
                for(x=0;x<w;x++) *((short*)(dst+x*2))=*((short*)(src+(w-x-1)*2));
            }
            break;
        case 3:
            for(x=0;x<w;x++){
                dst[x*3+0]=src[0+(w-x-1)*3];
                dst[x*3+1]=src[1+(w-x-1)*3];
                dst[x*3+2]=src[2+(w-x-1)*3];
            }
            break;
        case 4:
            for(x=0;x<w;x++) *((int*)(dst+x*4))=*((int*)(src+(w-x-1)*4));
        }
        src+=srcstride;
        dst+=dststride;
    }
}

