#include <math.h>

#include <inttypes.h>

static void process_C(uint8_t *udst, uint8_t *vdst, uint8_t *usrc, uint8_t *vsrc, int dststride, int srcstride,
                    int w, int h, float hue, float sat)
{
        int i;
        const int s= rint(sin(hue) * (1<<16) * sat);
        const int c= rint(cos(hue) * (1<<16) * sat);

        while (h--) {
                for (i = 0; i<w; i++)
                {
                        const int u= usrc[i] - 128;
                        const int v= vsrc[i] - 128;
                        int new_u= (c*u - s*v + (1<<15) + (128<<16))>>16;
                        int new_v= (s*u + c*v + (1<<15) + (128<<16))>>16;
                        if(new_u & 768) new_u= (-new_u)>>31;
                        if(new_v & 768) new_v= (-new_v)>>31;
                        udst[i]= new_u;
                        vdst[i]= new_v;
                }
                usrc += srcstride;
                vsrc += srcstride;
                udst += dststride;
                vdst += dststride;
        }
}

